define(["plugins/text!widgets/templates/popup.html"], function(template) {
    return function(args) {
        return {
            init: function() {
                jQuery.extend(this, args);
                this.template = jQuery(template)
                    .clone();
                this.domNode = this.template.get();
                if (this.container) this.container.append(this.template);
                else jQuery('body')
                    .append(this.template);
                this.template.find('.discard')
                    .on('click', jQuery.proxy(this.discard, this));
                this.template.on('touchmove mousedown mousemove swipe', function(event) {
                    // preventing page swipe event if present
                    event.stopImmediatePropagation();
                });
                this.setValues(this.title, this.contents, this.iconTitleURL);
                jQuery(window)
                    .on("resize", jQuery.proxy(this.discard, this, 1));
                jQuery(this.template)
                    .find('.overlay')
                    .on('click', jQuery.proxy(this.discard, this, 1));

                this.template.find(".close-icon").attr({
                	src: path + "../images/close.png"
                });
            },
            setValues: function(title, contents, iconTitleURL) {
                this.setTitle(title);
                this.setIconTitle(iconTitleURL);
                this.setContents(contents);
            },
            setTitle: function(title) {
                var titleElem = this.template.find('.title');
                if (title) titleElem.html(title)
                    .show();
                else titleElem.hide();
            },
            setContents: function(contents) {
                var contentsElem = this.template.find('.contents');
                if (contents) contentsElem.html(contents)
                    .show();
                else contentsElem.hide();
            },
            setIconTitle: function(iconTitleURL) {
                var iconTitleElem = this.template.find('.icon img');
                if (iconTitleURL) {
                    iconTitleElem.show()
                        .attr({
                            src: iconTitleURL
                        })
                        .removeClass("hidden")
                        .show();
                    this.template.find('.icon')
                        .removeClass("hidden");
                } else {
                    this.template.find('.icon')
                        .addClass("hidden");
                    iconTitleElem.addClass("hidden")
                        .hide();
                }
            },
            setWidth: function(width) {
                this.template.find('.content')
                    .css({
                        width: width
                    });
            },
            display: function(speed) {
                if (!this.visible) {
                    this.template.fadeIn(speed || 400);
                    this.visible = true;
                }
            },
            discard: function(speed) {
                if (this.visible) {
                    this.template.fadeOut(speed || 400);
                    this.visible = false;
                }
            }
        }
    }
});

